Attribute VB_Name = "COMMONS"
'most variables are double-precision for maximum accuracy
'please review the Vocation.frm Form_Load event for more definitions and assignments
DefDbl A-Z

Global MC_ruler_pnum%           'MC ruler planet number

Global wheelsWindowTop%, wheelsWindowLeft%, wheelsWindowHeight%, wheelsWindowWidth%

'used in generation of Swiss ephemeris data
Global iday%, imonth%, iyear%, ihour!, imin!, tjd_ut, tdj_et, lon, lat

'added 11 Jan 2003 for updating by time increments
'used in the updating by day, hour, or minute routines in WHEELS
Global DaysInMonth%(12)
Global LastMonth%, LastDay%, LastYear%, LastHour!, LastMinute!, LastAmPm%
Global LastLongDeg%, LastLongMin%, LastLatDeg%, LastLatMin%
Global LastLongEW%, LastLatNS%, LastTZ!
Global InUpdate%


'Arrays
'------
'these arrays hold the natal positions of the planets
'the order of the planets is Sun, Mercury, Venus - Pluto, Moon, N. Node, S. Node, Part of Fortune, Asc, and MC
'16 total at present
Global Natal(), NatalHouse(13)

'these arrays hold house cusp data, longitude data, and angle data for where the planet is in the chartwheel display
Global CWHC(13), CWPlanets(), CWPlanetAngle_Y(), CWPlanetAngle_X(), CWPlanetAngle()

'these are used for holding the angle and radius data for the chartwheel display
Global OCAngleX%(12), OCRadiusX%(12)
Global TheAngleX%(12), TheRadiusX%(12)
Global sign_names$(12)

'arrays filled with data needed to draw the chartwheel
Global HCUSPDATA%(120), XRADIUSX%(360), CuspAngle(12)

'arrays used to store the chartwheel captions
Global Wheels1Captions$(), Wheels2Captions$()

'house cusp data - the MC is element 1, the 11th house cusp is element 2, the 12th house is element 3,
'the Asc is element 4 and so on
Global HC(13)

'array that holds the number of planets in a particular house in the chartwheel
Global nopih(12)

'used to set whether a particular location in a house has been filled with a glyph
'Global SpotFilled%(115)
Global SpotFilled%(200)

'array used to store the number of degrees that make up each house
Global DegEachHouse(12)

'array used to determine where within a house a planet is displayed in the chartwheel
Global CWIndexy()

'Planets() holds temporary planetary longitude data
Global Planets()

'arrays used for sorting in the chartwheel display
Global sort(), sortpos(), HOME()

'array that holds the option settings
Global XOPTION!(244)

'house cusp arrays
Global HC3(13), HC1(13)

'arrays used to hold planetary names
Global PN$(), PNH$(), MPNames$()

'array used to hold various aspect orbs
Global ASPECTS%(17), CWAspects!(16)
Global Natal_Orbs!(16), tyl_natal_orbs!(16)
Global NAsp%()

'various arrays used in the Cosmic State (horary) calculations
Global PPS(), SpeedX(), SpeedOfNatal(), HoraryTempBuffer$(), peregrine()

'arrays used for input data storage from your .FIL data files
Global DataFile1$(), DataFile2$(), DataFile3$(), DataFile4$()
Global DataFile5$(), DataFile6$(), DataFile7$(), DataFile8$()

'arrays used to hold geograhic data from your .LL data files
Global GeoDataFile1$(), GeoDataFile2$(), GeoDataFile3$(), GeoDataFile4$()

'arrays used to hold the data in the text displays in the OutputD1 form
Global OutputLines$(), TextOnForm$()

'arrays used in report writer routines
Global ReportLineCounter&, CurrentReportLine$
Global Page1$(), Page2$(), Page3$(), Page4$(), Page5$()
Global Page6$(), Page7$(), Page8$(), Page9$(), Page10$()
Global Page11$(), Page12$(), Page13$(), Page14$(), Page15$()
Global Page16$(), Page17$(), Page18$(), Page19$(), Page20$()
Global Page21$(), Page22$(), Page23$(), Page24$(), Page25$()

'used in ACS Atlas routines
'atlas_present% = 0 if no atlas present, else 1 = ACS Atlas present (checked in MDIForm_Load of Westran.frm)
Global atlas_present%
Global AtlasLongitude$, AtlasLatitude$, AtlasTimeZone!, ErrFlag%
'Global AtlasState_Country$, AtlasCity$


'Variables
'---------
'number of planets and points to keep track of - see above under Arrays
Global NumberOfPlanets%
Global sun_moon_mp As Double
Global jupiter_pluto_mp As Double

'these are used for chartwheel display (see also X1, Y1)
Global Angle, Radius, FromCusp
Global h1 As String, H3 As String, PlanetsDone%
Global MaxInHouse%, DegreeIncrement
Global x2, X3, x4, y2

'outer wheel radius ofr chartwheel display
Global OuterWheelRadius%

'used in chartwheel display for scaling, type of chartwheel (single or dual), and more
Global StartScale%, NoDo%, NotDo%, PrntObj%

'variable used in the opening title/splash screen while data tables is loading
Global splash%

'variables used in the AstroLine display
Global SLX, ELX, SLY

'variables used in text display of data
Global Buffer As String, LineCounter&, TextLineCounter&

'miscellaneous variables and strings
Global Idx1%, Idx2%, Idx3%, Idx4%, Idx5%
Global NumLines%, WhereAt%, PersonalInfo$()
Global LinesOfPersonalInfo%, XTitleX$, OrigTitle$, FileToLookAt$
Global ClosingMark1Encrypted$, ClosingMark2Encrypted$

Global ax1 As String, AAX1 As String, d1 As String, d2 As String
Global crlf As String
Global Retrograde As String, HCX1 As String
Global Latitude As String, Longitude As String
Global PX1 As String, ph$, SX1 As String, SiderealTime As String
Global ZN As String, HS As String, SidTime
Global CWRetrograde As String
Global NatalH As String, NatalST As String, NatalPH$, NatalD1 As String, NatalD2 As String
Global NatalDate As String, NatalBirthTime As String
Global AMorPM As String, OrigFontName As String, MasterFontName As String
Global SelectedFile As String, NameOfFile As String, OutputNameFile As String
Global DefaultDirectory As String, Calendar$
Global Speed As String, XY$
Global Name2ndPerson$, CurrentNamesFile$, CurrentOrbsFile$
Global CurrentGeographyFile$, Msg1x As String
Global RSVP%, IDX%

'variables used in printed chartwheel aspect grid - there is no on-screen aspect grid on the chartwheel display
Global BottomCornerX, BottomCornerY, TopCornerX, TopCornerY
Global XCaption$, WhereLeftOff%, NichtProcess%
Global LockList%, NoNo%
Global NameFile As String, NamesFileIndex%

Global MasterFontSize, OrigFontSize
Global MasterScaleWidth, MasterScaleHeight, MasterWidth, MasterHeight
Global MasterFontBold, MasterFontItalic, XResolution%, CurrentHelpFile$
Global PlanetScaling, InputErrorFlag%
Global Interpretations%, InterpretJD#, HoraryTempCntr%
Global GlyphCharacterWidth%, NumeralCharacterWidth%, OrigWheelsWidth
Global GlyphCharacterHeight%, NumeralCharacterHeight%
Global OrigWheelsLeft, PFntSz%, WheelBackground%
Global Help1%, EuroC%, ShellWorked&
Global DataWindowTop%, DataWindowLeft%, DataWindowHeight%, DataWindowWidth%
Global MyiDate%, MyiTime%

Global A, AB, AL, ARF, AU, aa, AX, AP%
Global B, BK, BR, BETA
Global c, C1, CA, CO, COL, CORR, CR
Global D, DA, DD
Global DAYY
Global e, EX, F, FE, FR, FX, FZ
Global G
Global H, HOUSEY
Global I, IM, INDEXY
Global J, jd, JU, jdx
Global K, KK, L, LF1, LA, LG, LO
Global LAMBDA, LL
Global M, MM, MA, ML, MLN, MO
Global N, NU
Global NatalDay%, NatalMonth%, NatalYear%, NatalTime!
Global NatalTimeZone!, NatalLong!, NatalLat!, NatalJD
Global O, OA, OB
Global p, PI, PL, PT, q
Global R, R1, RD, RA, ROW, RHO
Global s, s1, s2, s3, SP, SS
Global t, temp, temp1, TEMP2X, TEMP3X, temp7, TEMP19, TH, TT, TLN
Global U
Global v#
Global w
Global X, x1, XJD, xx, XYear, XMonth, XDAY, XIM
Global Y, y1
Global z, z1, z2, z2a, z3, ZETA


'Windows variable definition
' Colors
Global Const BLACK = &H0&
Global Const RED = &HFF&
Global Const GREEN = &HFF00&
Global Const YELLOW = &HFFFF&
Global Const BLUE = &HFF0000
Global Const MAGENTA = &HFF00FF
Global Const CYAN = &HFFFF00
Global Const WHITE = &HFFFFFF
Global Const GRAY = &HC0C0C0

' System Colors
Global Const SCROLL_BARS = &H80000000           ' Scroll-bars gray area.
Global Const DESKTOP = &H80000001               ' Desktop.
Global Const ACTIVE_TITLE_BAR = &H80000002      ' Active window caption.
Global Const INACTIVE_TITLE_BAR = &H80000003    ' Inactive window caption.
Global Const MENU_BAR = &H80000004              ' Menu background.
Global Const WINDOW_BACKGROUND = &H80000005     ' Window background.
Global Const WINDOW_FRAME = &H80000006          ' Window frame.
Global Const MENU_TEXT = &H80000007             ' Text in menus.
Global Const WINDOW_TEXT = &H80000008           ' Text in windows.
Global Const TITLE_BAR_TEXT = &H80000009        ' Text in caption, size box, scroll-bar arrow box..
Global Const ACTIVE_BORDER = &H8000000A         ' Active window border.
Global Const INACTIVE_BORDER = &H8000000B       ' Inactive window border.
Global Const APPLICATION_WORKSPACE = &H8000000C ' Background color of multiple document interface (MDI) applications.
Global Const HIGHLIGHT = &H8000000D             ' Items selected item in a control.
Global Const HIGHLIGHT_TEXT = &H8000000E        ' Text of item selected in a control.
Global Const BUTTON_FACE = &H8000000F           ' Face shading on command buttons.
Global Const BUTTON_SHADOW = &H80000010         ' Edge shading on command buttons.
Global Const GRAY_TEXT = &H80000011             ' Grayed (disabled) text.  This color is set to 0 if the current display driver does not support a solid gray color.
Global Const BUTTON_TEXT = &H80000012           ' Text on push buttons.

' MsgBox parameters
Global Const MB_OK = 0                 ' OK button only
Global Const MB_OKCANCEL = 1           ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2   ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3        ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4              ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons

Global Const MB_ICONSTOP = 16          ' Critical message
Global Const MB_ICONQUESTION = 32      ' Warning query
Global Const MB_ICONEXCLAMATION = 48   ' Warning message
Global Const MB_ICONINFORMATION = 64   ' Information message

Global Const MB_APPLMODAL = 0          ' Application Modal Message Box
Global Const MB_DEFBUTTON1 = 0         ' First button is default
Global Const MB_DEFBUTTON2 = 256       ' Second button is default
Global Const MB_DEFBUTTON3 = 512       ' Third button is default
Global Const MB_SYSTEMMODAL = 4096      'System Modal

' MsgBox return values
Global Const IDOK = 1                  ' OK button pressed
Global Const IDCANCEL = 2              ' Cancel button pressed
Global Const IDABORT = 3               ' Abort button pressed
Global Const IDRETRY = 4               ' Retry button pressed
Global Const IDIGNORE = 5              ' Ignore button pressed
Global Const IDYES = 6                 ' Yes button pressed
Global Const IDNO = 7                  ' No button pressed

'File Open/Save Dialog Flags
Global Const OFN_READONLY = &H1&
Global Const OFN_OVERWRITEPROMPT = &H2&
Global Const OFN_HIDEREADONLY = &H4&
Global Const OFN_NOCHANGEDIR = &H8&
Global Const OFN_SHOWHELP = &H10&
Global Const OFN_NOVALIDATE = &H100&
Global Const OFN_ALLOWMULTISELECT = &H200&
Global Const OFN_EXTENSIONDIFFERENT = &H400&
Global Const OFN_PATHMUSTEXIST = &H800&
Global Const OFN_FILEMUSTEXIST = &H1000&
Global Const OFN_CREATEPROMPT = &H2000&
Global Const OFN_SHAREAWARE = &H4000&
Global Const OFN_NOREADONLYRETURN = &H8000&

'Text Box Flags
Global Const WM_USER = &H400
Global Const EM_SETREADONLY = (WM_USER + 31)

