Attribute VB_Name = "MODULE1"
Sub AdjustForm()
    Dim X&

    If LineCounter& = 0 Or OutputD1.ScaleHeight = 0 Then Exit Sub
    Call LineFeed

    Open DefaultDirectory$ + "\REPORTS\LASTPAGE.TXT" For Output As #9
    For X& = 0 To TextLineCounter&
        Print #9, TextOnForm$(X&)
    Next X&

    Close #9
    OutputD1!RichText1.LoadFile DefaultDirectory$ + "\REPORTS\LASTPAGE.TXT", 1
    OutputD1.Show
    OutputD1.Caption = XCaption$ & "Data"
End Sub

Sub CheckInputErrors()
    If Val(InputD!txtMonth) = 0 Or Val(InputD!txtDay) = 0 Or Val(InputD!txtYear) = 0 Then
       Call SetErrorFlagNatalData
    End If
    If InputD!txtMonth = "" Or InputD!txtDay = "" Or InputD!txtYear = "" Then
       Call SetErrorFlagNatalData
    End If
    If InputD!txtBirthHour = "" Or InputD!txtBirthMinute = "" Or InputD!txtTZ = "" Then
        Call SetErrorFlagNatalData
    End If
    If InputD!txtLongDeg = "" Or InputD!txtLongMin = "" Then
        Call SetErrorFlagNatalData
    End If
    If InputD!txtLatDeg = "" Or InputD!txtLatMin = "" Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtTZ) < -2 And InputD!optWest.value = True Then
        Call SetErrorFlagNatalData
    End If
End Sub

Sub CheckLatitudeErrors()
'this is no longer required when using the Swiss ephemeris
'    If HS$ = "P" Or HS$ = "K" Then
'        If Val(InputD!txtLatDeg) >= 66 And Val(InputD!txtLatMin) > 0 Then
'            InputErrorFlag% = 1
'            MsgBox "Your latitude is too high. Lower to 66 degrees, 00 minutes or below OR change house systems.", 64, "Warning!"
'        End If
'    End If
End Sub

Sub CheckOverflowErrorsNatal()
    If Val(InputD!txtMonth) > 12 Or Val(InputD!txtDay) > 31 Or Val(InputD!txtYear) > 2099 Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtBirthHour) > 12 Or Val(InputD!txtBirthMinute) > 59 Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtTZ) > 12 Or Val(InputD!txtTZ) < -13 Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtLongDeg) > 180 Or Val(InputD!txtLongMin) > 59 Then
        Call SetErrorFlagNatalData
    End If
    If Val(InputD!txtLatMin) > 59 Then
        Call SetErrorFlagNatalData
    End If
    'If Val(InputD!txtYear) < 100 Then
    '    Call SetErrorFlagNatalData
    'End If
End Sub

Sub ClearOutputForm()
    OutputD1.ScaleMode = 4
    If Interpretations% = 1 Then
        Interpretations% = 0
        OutputD1!mnuMore.Visible = False
    End If
    
    TextLineCounter& = 0: 'clear buffer for form
    ReDim TextOnForm$(0 To 1)
End Sub

Sub Convert360toDM()
        z3 = Int(z): q = Int(z3 / 30) + 1
        z1 = Int(RoundTo2Dec((z3 / 30 - Int(z3 / 30)) * 30))
        z2a = (z - z3) * 60
        z2 = Int(z2a + 0.5): If z2 >= 60 Then z2 = 59: 'fixed 4-26-91
End Sub

Sub Convert360toDMS()
        z3 = Int(z): q = Int(z3 / 30) + 1
        z1 = Int(RoundTo2Dec((z3 / 30 - Int(z3 / 30)) * 30))
        z2a = (z - z3) * 60: z2 = Int(z2a)
        z2a = Int((z2a - Int(z2a)) * 60)
End Sub

Function ConvertDMtoDec(X)
        ConvertDMtoDec = Int(X) + ((X - Int(X)) * 100) / 60
End Function

Function DEGREES(X)
        DEGREES = X * 180 / 3.1415926535
End Function

Sub FetchNatalData()
        D = InputD!txtDay.Text: y = InputD!txtYear.Text
        M = InputD!txtMonth.Text: t = InputD!txtTZ.Text
        NatalDay% = D: NatalMonth% = M: NatalYear% = y
        If MyiDate% = 2 Then
            Calendar$ = InputD!txtYear.Text + "/" + InputD!txtMonth.Text + "/" + InputD!txtDay.Text
        ElseIf MyiDate% = 1 Then
            Calendar$ = InputD!txtDay.Text + "/" + InputD!txtMonth.Text + "/" + InputD!txtYear.Text
        Else
            Calendar$ = InputD!txtMonth.Text + "/" + InputD!txtDay.Text + "/" + InputD!txtYear.Text
        End If
        NatalDate$ = Calendar$
        F = InputD!txtBirthHour.Text + InputD!txtBirthMinute.Text / 100
        NatalTime! = F: NatalTimeZone! = t

        If InputD!optAM.value = -1 Then NatalBirthTime$ = "A.M." Else NatalBirthTime$ = "P.M."
        AMorPM$ = NatalBirthTime$

        NatalLong! = InputD!txtLongDeg.Text + InputD!txtLongMin.Text / 100
        If InputD!optEast.value = -1 Then
            NatalLong! = -NatalLong!
        End If
        If NatalLong! < 0 Then
            NatalD1$ = "East"
        Else
            NatalD1$ = "West"
        End If

        NatalLat! = InputD!txtLatDeg.Text + InputD!txtLatMin.Text / 100
        If InputD!optSouth.value = -1 Then
            NatalLat! = -NatalLat!
        End If
        If NatalLat! < 0 Then
            NatalD2$ = "South"
        Else
            NatalD2$ = "North"
        End If
End Sub

Sub GetAspectOptions()
    Dim c As Integer, I As String

    Close #2: c = 0
    Open CurrentOrbsFile$ For Input As #2
    Do While Not EOF(2)
       Line Input #2, I
       If I = "" Then Exit Do
       c = c + 1: CWAspects!(c) = Val(Left$(I, 7))
    Loop
    Close #2
End Sub

Sub GetOptions()
    Dim c As Integer, I As String

    Close #2: c = 0
    Open DefaultDirectory + "\OPTIONS.OPT" For Input As #2
    Do While Not EOF(2)
       Line Input #2, I
       If I = "" Then Exit Do
       c = c + 1: XOPTION!(c) = Val(Left$(I, 7))
    Loop
    Close #2
End Sub

Sub HouseCaptions()
    If HS$ = "P" Then Wheels1Captions$(7) = "Placidus"
    If HS$ = "R" Then Wheels1Captions$(7) = "Regiomontanus"
    If HS$ = "K" Then Wheels1Captions$(7) = "Koch"
    If HS$ = "C" Then Wheels1Captions$(7) = "Campanus"
    If HS$ = "O" Then Wheels1Captions$(7) = "Porphyry"
    If HS$ = "B" Then Wheels1Captions$(7) = "Alcabitus"
    If HS$ = "T" Then Wheels1Captions$(7) = "Topocentric"
End Sub

Sub HOUSELIST()
'print out all 12 house cusps
    Call LineFeed: Buffer = Space(2) + "HOUSE CUSPS - "

    If HS$ = "R" Then Buffer = Buffer + "Regiomontanus"
    If HS$ = "P" Then Buffer = Buffer + "Placidus"
    If HS$ = "K" Then Buffer = Buffer + "Koch"
    If HS$ = "C" Then Buffer = Buffer + "Campanus"
    If HS$ = "O" Then Buffer = Buffer + "Porphyry"
    If HS$ = "B" Then Buffer = Buffer + "Alcabitus"
    If HS$ = "T" Then Buffer = Buffer + "Topocentric"

    Call PrintBuffer: Buffer = "": LF1 = 0
    For I = 1 To 12
        z = HC(I)
        If LF1 = 0 Then
            Buffer = Buffer + Space(2)
        Else
            Buffer = Buffer + Space(1)
        End If
        Buffer = Buffer + Mid$(HCX1$, I * 4 - 3, 4) + " house = "
        Call PrintSignData
        LF1 = LF1 + 1: If LF1 = 3 Then Call PrintBuffer: LF1 = 0: Buffer = ""
    Next I
End Sub

Sub LineFeed()
        Buffer = "": Call PrintBuffer
End Sub

Sub NatalCaptions()
    ReDim Wheels1Captions$(7)
    Wheels1Captions$(1) = ZN$ & " - natal"
    Wheels1Captions$(2) = Format$(NatalDate$, "dd mmm yyyy")
    Wheels1Captions$(3) = Format$(NatalTime!, "#0.00") & " " & AMorPM$ & " (" & NatalTimeZone! & ")"
    Wheels1Captions$(4) = DisplayLLproperly(NatalLong!, NatalD1$)               'Format$(Abs(NatalLong!), "##0.00") & " " & NatalD1$
    Wheels1Captions$(5) = DisplayLLproperly(NatalLat!, NatalD2$)                  'Format$(Abs(NatalLat!), "#0.00") & " " & NatalD2$
    Wheels1Captions$(6) = NatalST
    Call HouseCaptions: ReDim Wheels2Captions$(7)
End Sub

Sub NatalDataList()
        Call LineFeed
        Buffer = Space(2) & ZN$: Call PrintBuffer
        Buffer = Space$(2) + Format$(NatalDate$, "dd mmm yyyy") + Space$(4) + "TZ = " + Format$(NatalTimeZone!, "##0.0")
        Buffer = Buffer + Space$(6) + Format$(NatalTime!, "#0.00") + " " + NatalBirthTime$
        
        'Buffer = Buffer + Space$(3) + Format$(Abs(NatalLat!), "##0.00") + " " + NatalD2$ + Space(4) + Format$(Abs(NatalLong!), "##0.00") + " " + NatalD1$
        Buffer = Buffer + Space$(3) + DisplayLLproperly(NatalLong!, NatalD1$) + Space(4) + DisplayLLproperly(NatalLat!, NatalD2$)
        
        Call PrintBuffer
End Sub

Sub NatalList()
    For XAO% = 1 To NumberOfPlanets%
        Planets(XAO%) = Natal(XAO%)
    Next XAO%
    
    For XAP% = 1 To 13
        HC(XAP%) = NatalHouse(XAP%)
    Next XAP%
        
    Retrograde$ = NatalH$

    Call HOUSELIST
    Call NatalPlanetList
End Sub

Sub NatalPlanetList()
    Call LineFeed
        
    I = 1: Call PlanetSR1
    Call PrintBuffer
        
    I = 10: Call PlanetSR1
    Call PrintBuffer
    
    For I = 2 To NumberOfPlanets%
        Call PlanetSR1
        Call PrintBuffer
    Next I
End Sub

Function PickAFile(Wild As String) As String
    Dim X%

    Load SelectFIle
    SelectFIle.filList.Pattern = Wild
    SelectedFile = CurrentNamesFile$
    SelectFIle!filList.ListIndex = 0
    For X% = 0 To SelectFIle!filList.ListCount - 1
        If UCase$(Right$(CurrentNamesFile$, Len(SelectFIle!filList.List(X%)))) = UCase$(SelectFIle!filList.List(X%)) Then
           SelectFIle!filList.ListIndex = X%: Exit For
        End If
    Next X%

    SelectFIle.Show 1
    PickAFile = SelectedFile
End Function

Function PickAFile2(Wild As String) As String
    Dim X%

    Load SelectFIle
    SelectFIle.filList.Pattern = Wild
    SelectedFile = CurrentGeographyFile$
    SelectFIle!filList.ListIndex = 0
    For X% = 0 To SelectFIle!filList.ListCount - 1
        If UCase$(Right$(CurrentGeographyFile$, Len(SelectFIle!filList.List(X%)))) = UCase$(SelectFIle!filList.List(X%)) Then
           SelectFIle!filList.ListIndex = X%: Exit For
        End If
    Next X%

    SelectFIle.Show 1
    PickAFile2 = SelectedFile
End Function

Sub PlanetSR1()
    z = Planets(I)
    Buffer = Space(2)
    Call PrintSignDataSeconds
    
    Buffer = Buffer + Space(3) + Mid$(PX1$, I * 10 - 9, 10) + Mid$(Retrograde$, I, 1) + Space(4)
    
    Buffer = Buffer + "(" + Mid$(NatalPH$, I * 10 - 9, 10) + ")" + Space(4)
End Sub

Sub PrintBuffer()
    On Error GoTo PBErr1
    ReDim Preserve OutputLines$(0 To LineCounter& + 1)
    OutputLines$(LineCounter&) = Buffer
    LineCounter& = LineCounter& + 1

    TextOnForm$(TextLineCounter&) = Buffer
    TextLineCounter& = TextLineCounter& + 1
    ReDim Preserve TextOnForm$(0 To TextLineCounter&)
PBErr2: Exit Sub

PBErr1: MsgBox "Buffer cannot hold any more data. Please print and/or clear data buffer before displaying any more data. This message may appear up to 35 times depending on how full the buffer is and how much the program wants to write to it.", 16, "Warning!"
    Resume PBErr2
End Sub

Sub PrintSignData()
    Call Convert360toDM

    Buffer = Buffer & Format$(z1, "00") & " " & Mid$(SX1$, q * 3 - 2, 3) & " "
    Buffer = Buffer & Format$(z2, "00")
End Sub

Sub PrintSignDataSeconds()
        Call Convert360toDMS
        Buffer = Buffer + Format$(z1, "00") + " " + Mid$(SX1$, q * 3 - 2, 3) + " "
        Buffer = Buffer + Format$(z2, "00") + "m " + Format$(z2a, "00") + "s"
End Sub

Function Radians(X)
        Radians = X * 3.1415926535 / 180
End Function

Sub RectToPolar()
'BK = radians along the X-axis, Y = radians along the Y-axis
        If y = 0 Then y = 0.00000000174533
        R = (BK * BK + y * y) ^ 0.5: A = Atn(y / BK): If A < 0 Then A = A + PI
        If y < 0 Then A = A + PI
End Sub

Function RoundTo2Dec(X)
        RoundTo2Dec = Int(X * 100 + 0.5) / 100
End Function

Sub SetErrorFlagNatalData()
       InputErrorFlag% = 1
       MsgBox "Error in natal input data section. Please correct.", 64, "Warning!"
End Sub

Function Sine(X)
        Sine = Sin(X * 3.1415926535 / 180)
End Function

Sub Get_natal_aspects()
        Dim tx$, DA1, k1()

        Call GetNatalOrbs

        ReDim NAsp%(NumberOfPlanets%, NumberOfPlanets%, 17), k1(NumberOfPlanets%)

're-order the planets - Moon goes after the Sun
        For X = 1 To NumberOfPlanets%
            k1(X) = Planets(X)
        Next X

        DA1 = k1(10)
        For X = 9 To 2 Step -1
            k1(X + 1) = k1(X)
        Next X
        k1(2) = DA1

'print out planet's aspects in graph-type form
        tx$ = "  Planet     Planet    Separation   Degrees from exact" & crlf
        Call LineFeed
        Buffer = Space(22) + "NATAL PLANET ASPECTS TO NATAL PLANETS": Call PrintBuffer
        Call LineFeed
        
        Buffer = Space(8) + "MC  Asc  N.N  Plu  Nep  Ura  Sat  Jup  Mar  Ven  Mer  Moo"
        Call PrintBuffer
        
        For y = 1 To NumberOfPlanets% - 1
            If y = 11 Then
                Buffer = Space(2) + "N.N  "
            ElseIf y = NumberOfPlanets% Then
                Buffer = Space(2) + "MC   "
            Else
                Buffer = Space(2) + Left$(MPNames$(y), 3) + "  "
            End If
            
            For X = NumberOfPlanets% To 2 Step -1
                If y >= X Then GoTo PT2G

                q = 1: DA = Abs(k1(y) - k1(X)): If DA > 180 Then DA = 360 - DA
                If DA <= (60 + Natal_Orbs!(2)) And DA >= (60 - Natal_Orbs!(2)) Then q = 3: DA1 = DA - 60
                If DA <= (90 + Natal_Orbs!(3)) And DA >= (90 - Natal_Orbs!(3)) Then q = 4: DA1 = DA - 90
                If DA <= (120 + Natal_Orbs!(4)) And DA >= (120 - Natal_Orbs!(4)) Then q = 5: DA1 = DA - 120
                If DA >= (180 - Natal_Orbs!(5)) Then q = 6: DA1 = DA - 180
                If DA <= (30 + Natal_Orbs!(7)) And DA >= (30 - Natal_Orbs!(7)) Then q = 8: DA1 = DA - 30
                If DA <= (45 + Natal_Orbs!(8)) And DA >= (45 - Natal_Orbs!(8)) Then q = 9: DA1 = DA - 45
                If DA <= (135 + Natal_Orbs!(9)) And DA >= (135 - Natal_Orbs!(9)) Then q = 10: DA1 = DA - 135
                If DA <= (150 + Natal_Orbs!(10)) And DA >= (150 - Natal_Orbs!(10)) Then q = 11: DA1 = DA - 150
                If DA <= (36 + Natal_Orbs!(11)) And DA >= (36 - Natal_Orbs!(11)) Then q = 12: DA1 = DA - 36
                If DA <= (40 + Natal_Orbs!(12)) And DA >= (40 - Natal_Orbs!(12)) Then q = 13: DA1 = DA - 40
                If DA <= (72 + Natal_Orbs!(13)) And DA >= (72 - Natal_Orbs!(13)) Then q = 14: DA1 = DA - 72
                If DA <= (108 + Natal_Orbs!(14)) And DA >= (108 - Natal_Orbs!(14)) Then q = 15: DA1 = DA - 108
                If DA <= (144 + Natal_Orbs!(15)) And DA >= (144 - Natal_Orbs!(15)) Then q = 16: DA1 = DA - 144
                If DA <= (165 + Natal_Orbs!(16)) And DA >= (165 - Natal_Orbs!(16)) Then q = 17: DA1 = DA - 165
                If DA <= Natal_Orbs!(1) Then q = 2: DA1 = DA
                If q = 1 Or q > 17 Then Buffer = Buffer + "---  ": GoTo PT2G
                NAsp%(y, X, q) = 1
                If ASPECTS%(q) < 10 Then
                    Buffer = Buffer + "  " + Format$(ASPECTS%(q), "0") + "  "
                ElseIf ASPECTS%(q) < 100 Then
                    Buffer = Buffer + " " + Format$(ASPECTS%(q), "00") + "  "
                Else
                    Buffer = Buffer + Format$(ASPECTS%(q), "000") + "  "
                End If
                If y <> 12 Then
                    tx$ = tx$ & Space(2) & MPNames$(y) & Space(10 - Len(MPNames$(y)) + 1) & MPNames(X) & Space(10 - Len(MPNames$(X)) + 1)
                    tx$ = tx$ & Align3(Format$(Fix(DA), "##0")) & "d" & Space(1) & Format$((Abs(DA) - Int(Abs(DA))) * 60, "00") & "m" & Space(7)
                    tx$ = tx$ & Align4(Format$(Fix(Abs(DA1)), "#0")) & "d" & Space(1) & Format$((Abs(DA1) - Int(Abs(DA1))) * 60, "00") & "m" & crlf
                End If
PT2G:       Next X
            Call PrintBuffer
        Next y

        Call LineFeed: Buffer = tx$: Call PrintBuffer
End Sub

Function Align3(A4 As String)
    If Val(A4) >= 100 Then
        Align3 = A4: Exit Function
    ElseIf Val(A4) >= 10 Then
        Align3 = Space(1) & A4: Exit Function
    Else
        Align3 = Space(2) & A4
    End If
End Function

Function Align4(A4 As String)
    If Left$(A4, 3) = "-0," Then
        Align4 = Space(2) & A4: Exit Function
    ElseIf Val(A4) >= 100 Then
        Align4 = Space(1) & A4: Exit Function
    ElseIf Val(A4) >= 10 Then
        Align4 = Space(2) & A4: Exit Function
    ElseIf Val(A4) >= 0 Then
        Align4 = Space(3) & A4: Exit Function
    ElseIf Val(A4) > -10 Then
        Align4 = Space(2) & A4: Exit Function
    ElseIf Val(A4) > -100 Then
        Align4 = Space(1) & A4: Exit Function
    Else
        Align4 = A4
    End If
End Function

Public Function DisplayLLproperly(value As Single, nsew$) As String
    Dim t$, LL$, X%

    LL$ = Format$(Abs(value), "##0.00")
    t$ = LCase$(Left$(nsew$, 1))

    X% = InStr(LL$, ".")
    If X% > 0 Then
        Mid$(LL$, X%, 1) = t$
    Else
        X% = InStr(LL$, ",")
        If X% > 0 Then
            Mid$(LL$, X%, 1) = t$
        End If
    End If

    DisplayLLproperly = LL$
End Function

Sub XHeader1()
    Call ClearOutputForm
    Call NatalDataList
End Sub

Public Sub GetNatalOrbs()
    Dim c As Integer, I As String

    Close #2: c = 0
    Open DefaultDirectory + "\NATAL.ORB" For Input As #2

    Do While Not EOF(2)
       Line Input #2, I
       If I = "" Then Exit Do
       c = c + 1: Natal_Orbs!(c) = Val(Left$(I, 7))
    Loop
    Close #2
End Sub

Public Sub Get_Tyl_Natal_Orbs()
    Dim c As Integer, I As String

    Close #2
    c = 0
    
    Open DefaultDirectory + "\Tyl_Natal_Orbs.ORB" For Input As #2

    Do While Not EOF(2)
       Line Input #2, I
       
       If I = "" Then Exit Do
       
       c = c + 1
       
       tyl_natal_orbs!(c) = Val(Left$(I, 7))
    Loop
    
    Close #2
End Sub


Sub GetCalendarDay()
    Dim A$, X$, LW, ITW, KW, IKW, NW, JTW

'convert Julian Day (JD#) to day, month, year format
    LW = Int(jd# + 0.5) + 68569: NW = Int(4 * LW / 146097)
    LW = LW - Int((146097 * NW + 3) / 4)
    ITW = Int(4000 * (LW + 1) / 1461001)
    LW = LW - Int(1461 * ITW / 4) + 31: JTW = Int(80 * LW / 2447)
    KW = LW - Int(2447 * JTW / 80)
    LW = Int(JTW / 11): JTW = JTW + 2 - 12 * LW
    IKW = 100 * (NW - 49) + ITW + LW
'JTW = month, KW = day, IKW = year
    X$ = Str$(JTW): If JTW < 10 Then X$ = "0" + LTrim$(X$)
    A$ = Str$(KW): If KW < 10 Then A$ = "0" + LTrim$(A$)
    X$ = LTrim$(X$): A$ = LTrim$(A$)
    If MyiDate% = 2 Then
        Calendar$ = LTrim$(Right$(Str$(IKW), 4) + "/" + X$ + "/" + A$)
    ElseIf MyiDate% = 1 Then
        Calendar$ = LTrim$(A$ + "/" + X$ + "/" + Right$(Str$(IKW), 4))
    Else
        Calendar$ = LTrim$(X$ + "/" + A$ + "/" + Right$(Str$(IKW), 4))
    End If
End Sub

Sub GetJulianDay()
'Find Julian Day for noon of day in question
        XIM = 12 * (XYear + 4800) + XMonth - 3
        XJD = (2 * (XIM - Int(XIM / 12) * 12) + 7 + 365 * XIM) / 12
        XJD = Int(XJD) + XDAY + Int(XIM / 48) - 32083
        If XJD <= 2299171 Then Exit Sub
        XJD = (XJD + Int(XIM / 4800) - Int(XIM / 1200) + 38)
End Sub

Sub GetXCaption()
    XCaption$ = "Vocation " & "(Tropical zodiac) - "
End Sub

Function Cosine(X)
        Cosine = Cos(X * PI / 180)
End Function

Function CRUNCH(X)
    If X >= 0 Then
        CRUNCH = X - Int(X / 360) * 360
    Else
        CRUNCH = 360 + (X - ((1 + Int(X / 360)) * 360))
    End If
End Function


